/*
 * Oobt@+荞݂𗘗pVAʐM
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/05/30
 * @version 1.0
 */
#include <stdio.h>
#include "AKI3694.h"
#include <common.h>
#include "sci.h"

/* M */
static fifo_char_size_t sci_write(fifo_char_t *, char *, fifo_char_size_t);
static void sci_send(volatile struct st_sci3 *, fifo_char_t *);

/* M */
static fifo_char_size_t sci_read(fifo_char_t *, char *, fifo_char_size_t);
static void sci_recieve(volatile struct st_sci3 *, fifo_char_t *);

/* obt@TCY */
static fifo_char_size_t sci_fifo_size(fifo_char_t *);

/* G[ */
static void sci_error_handler(volatile struct st_sci3 *);


/**********/
/*  SCI3  */
/**********/
#ifndef SCI3_DISABLE

static fifo_char_t fifo_tx3;
static fifo_char_t fifo_rx3;
static char buffer_tx3[SCI3_TX_BUFFER_SIZE + 1];
static char buffer_rx3[SCI3_RX_BUFFER_SIZE + 1];

/**
 * SCI3܂B
 * 
 */
void sci3_init(){
	fifo_char_init(&fifo_tx3, buffer_tx3, SCI3_TX_BUFFER_SIZE + 1);	
	fifo_char_init(&fifo_rx3, buffer_rx3, SCI3_RX_BUFFER_SIZE + 1);	

	/* SCI3̃WX^ݒ͂ɏ */
 
	/* ʐM SdʐM 
	 * ʐM[h [h 
	 * NbN NbN 
	 * f[^ 8bit 
	 * peB  
	 * Xgbvrbg 1bit
	 * rbg[g 9600bps(BRR=64@20MHz)
	 * 荞݁@TXI(Mf[^GveB)ARXI(Mf[^t)AERI(MG[)
	 */
  SCI3.SCR3.BYTE = 0x00;
	SCI3.SMR.BYTE = 0x00;
	SCI3.BRR = 64;
	int i; for(i = 0; i < 10000; i++);	// 1bitԑҋ@
	SCI3.SSR.BYTE &= 0x80;	// G[tONA
	SCI3.SCR3.BYTE |= 0xf0;	// 荞݋
	IO.PMR1.BIT.TXD = 1;
}

/**
 * SCI3瑗Mf[^o^܂B
 * 
 * @param data Mf[^
 * @param size Mf[^TCY
 * @return (int) Mobt@ɓo^ꂽf[^TCY
 */
fifo_char_size_t sci3_write(char *data, fifo_char_size_t size){
	fifo_char_size_t _size = sci_write(&fifo_tx3, data, size);
	/* 
	 * obt@̏Ԃ̂ƂTXI͈ꎞIɖɂȂĂ̂ŁA
	 * ēxLɂ
	 */
	if(_size > 0 && (SCI3.SCR3.BIT.TIE == 0)){SCI3.SCR3.BIT.TIE = 1;}
	return _size;
}

/**
 * SCI3̑Mobt@ɂ܂Ăf[^ʂԂ܂B
 * 
 * @return (int) SCI3̑Mobt@ɂ܂Ăf[^
 */
fifo_char_size_t sci3_tx_size(){return sci_fifo_size(&fifo_tx3);}

/**
 * SCI3Mf[^炢܂B
 * 
 * @param c Mf[^i[obt@
 * @param size Mf[^i[obt@̃TCY
 * @return (int) ۂɃobt@ǂݍ񂾃TCY
 */
fifo_char_size_t sci3_read(char *c, fifo_char_size_t size){return sci_read(&fifo_rx3, c, size);}

/**
 * SCI3̎Mobt@ɂ܂Ăf[^ʂԂ܂B
 * 
 * @return (int) SCI3̎Mobt@ɂ܂Ăf[^
 */
fifo_char_size_t sci3_rx_size(){return sci_fifo_size(&fifo_rx3);}

/* 荞ݏ */
#pragma interrupt
void int_sci3(){
	/* G[ */
  if(SCI3.SSR.BYTE & 0x38){
    /* tONA */
    SCI3.SSR.BYTE &= ~(0x38);
    sci_error_handler(&SCI3);
  }
  /* Mf[^GveB */
  if(SCI3.SSR.BIT.TDRE){
    sci_send(&SCI3, &fifo_tx3);
  }
  /* Mf[^t */
  if(SCI3.SSR.BIT.RDRF){
    sci_recieve(&SCI3, &fifo_rx3);
  }
}

#endif /* SCI3_DISABLE */

/************/
/*   ėp   */
/************/

/* M */
static fifo_char_size_t sci_write(fifo_char_t *fifo, char *data, fifo_char_size_t size){
	return fifo_char_write(fifo, data, size); /* Oobt@ɏ */
}

static void sci_send(volatile struct st_sci3 *sci, fifo_char_t *fifo){
	
	/* ރf[^邩mF */
	if(fifo_char_read(fifo, (char *)&(sci->TDR), 1) == 0){
		
		/* ރf[^Ȃ̂ŁAꎞITXI荞݂Ȃ悤ɂ */
		sci->SCR3.BIT.TIE = 0;
	}
}

/* M */
static fifo_char_size_t sci_read(fifo_char_t *fifo, char *c, fifo_char_size_t size){
	return fifo_char_read(fifo, c, size); /* Oobt@ǂݍ */
}

static void sci_recieve(volatile struct st_sci3 *sci, fifo_char_t *fifo){
	fifo_char_write(fifo, (char *)&(sci->RDR), 1); /* Oobt@1oCgo */
}

/* obt@TCY */
static fifo_char_size_t sci_fifo_size(fifo_char_t *fifo){
	return fifo_char_size(fifo);
}

/* G[ */
static void sci_error_handler(volatile struct st_sci3 *sci){
	
}
